//########## Military Headgear
//Script modified by Boodals. Origional credits to Gravity Cat

//Okay, so to clear stuff up here. An image's mountPoint var defines the physical location of the image on the player
//The %player.mountImage function designates what slot the image responds to, eg, in armor::onTrigger.
//I really should put a resource on coding help explaining that, I only just found out about it, i doubt many others do..


datablock AudioProfile(CombatGear_Equip) {
	filename = "./CombatGear_Equip.wav";
	description = AudioClose3d;
	preload = true;
};


exec("./Vest.cs");
exec("./Helmet.cs");


package gc_CombatGear_BoodPackage {
	function serverCmdDropTool(%client, %slot) {
		if(!isObject(%player = %client.player) || !isObject(%player.tool[%slot]))
			return parent::serverCmdDropTool(%client, %slot);

		%tool = %player.tool[%slot];

		if(!isObject(%tool))
			return parent::serverCmdDropTool(%client, %slot);

		if(isObject(%image = %player.getMountedImage(3)) && %image.isGCArmor && getSubStr(%name = %image.getName(), 3, strLen(%name) - 15) $= getSubStr(%name = %tool.getName(), 3, strLen(%name) - 7)) //Vests
			%player.schedule(5, unmountImage, 3);

		if(isObject(%image = %player.getMountedImage(2)) && %image.isGCArmor && getSubStr(%name = %image.getName(), 3, strLen(%name) - 15) $= getSubStr(%name = %tool.getName(), 3, strLen(%name) - 7)) //Hats
			%player.schedule(5, unmountImage, 2);

		return parent::serverCmdDropTool(%client, %slot);
	}

	function GameConnection::applyBodyParts(%client) {
		%r = Parent::applyBodyParts(%client);

		if(isObject(%player = %client.player)) {
			if(isObject(%image = %player.getMountedImage(2)) && %image.isGCArmor) {
				for(%i=0; $hat[%i] !$= ""; %i++)
					%player.hideNode($hat[%i]);

				for(%i=0; $accent[%i] !$= ""; %i++)
					%player.hideNode($accent[%i]);
			}
			if(isObject(%image = %player.getMountedImage(3)) && %image.isGCArmor) {
				%player.hideNode("armor");
			}
		}

		return %r;
	}

	function Armor::Damage(%this, %player, %sourceObject, %pos, %damage, %damageType) {
		if(isObject(%image = %player.getMountedImage(2)) && %image.isGCArmor) //Helmets
			if(getWord(%pos, 2) > getWord(%player.getWorldBoxCenter(), 2) - 3.3 * getWord(%player.getScale(), 2)) //If it hits above the neck
				%damage *= 0.6;
		
		if(isObject(%image = %player.getMountedImage(3)) && %image.isGCArmor) //Vests
			if(getWord(%pos, 2) < getWord(%player.getWorldBoxCenter(), 2) - 3.3 * getWord(%player.getScale(), 2)) //If it hits lower than neck
				%damage *= 0.5;

		parent::Damage(%this, %player, %sourceObject, %pos, %damage, %damageType);
	}

	function Player::mountImage(%player, %image, %slot, %loaded, %skin) {

		if(getSubStr(%image.getName(), 0, 4) $= "Pain" && isObject(%image2 = %player.getMountedImage(3)) && %image2.isGCArmor)
			return;

		return parent::mountImage(%player, %image, %slot, %loaded, %skin);
	}
};
activatepackage(gc_CombatGear_BoodPackage);